#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string>
#include <sstream>
#include "resource.h"
#include <fstream>
#include <iostream>

///////////////////// GLOBALS ////////////////////////////

 HWND hwnd, hOldCaptions, hNewCaptions;
 HWND hForward, hExports, hDone, hUserInfo;
 HWND hNumsEdit, hSetIndex;
 
 HMENU hMenuBar =CreateMenu();
 HMENU hFile = CreateMenu();
 
 std::string post_Caption;
 std::string getDrivePath;
 std::string baseFileName;
 std::string temp_eelFile;
 std::string temp_wavdata;
 std::string sound_sample;
 std::string exp_crcValues;
 std::string holdpathway;
 std::string temp_capdata;
 std::string cauLoca;
 std::string eelfileName;
 
 int EntryNo=0;
 int wavCount=0;
 int fileLoaded=0;
 int loadeddir=0;
 int countdown=0;
 
 unsigned long CauSampSize;
 unsigned long RobWyatt;
 unsigned long SampType;
 unsigned long Size_OfHeader;
 unsigned long Compress_Type;
 unsigned long size_of_Data;
 unsigned long size_of_Wave;
 unsigned long Sample_Rate;
 unsigned long BitRate_Chans;
 unsigned long OldCapLength;
 unsigned long OurHash_Value;
 unsigned long Is_Caption; 

 FILE *tpaFile;
 FILE *tempSample;
 FILE *outSample;
 
 
  void Retrieve_IDs ()
   { 

       std::string hashname;
       std::stringstream ghash;
        ghash.setf(std::ios::hex, std::ios::basefield);

        ghash<<OurHash_Value;
        
        std::string ValCheck;
        ValCheck=ghash.str();
        
        if(ValCheck.length()==8){
        hashname=ghash.str();
        }
        
        if(ValCheck.length()==7){
         hashname="0";
         hashname+=ghash.str();
         }
        
        if(ValCheck.length()==6){
         hashname="00";
         hashname+=ghash.str();
         }
         
        if(ValCheck.length()==5){
         hashname="000";
         hashname+=ghash.str();
         }
         
        std::string SndClip;
        std::string HexAlt=hashname;
        
        std::ifstream searchcrc(exp_crcValues.c_str(), std::ios::in);
        searchcrc.unsetf(std::ios::skipws);   /* read spaces */
        searchcrc.seekg(0, std::ios::beg);
        
        int IdFound=0;
        
         if (searchcrc.good()){
        
         while (std::getline(searchcrc, SndClip, ' ') && IdFound==0)
          {
          if(SndClip==hashname || SndClip==HexAlt){
         SndClip.erase();
         std::getline(searchcrc, SndClip, '\n');
         sound_sample=SndClip;
         IdFound = 1;
         sound_sample.erase(0,1);
         sound_sample.erase(sound_sample.length()-1, 1);
           }
         
         }
        searchcrc.close();
         }
		 
         if(IdFound==0 || sound_sample=="unknown"){
          std::stringstream dd;
          dd<<"EntryNo_";
          dd<<wavCount;
          dd>>sound_sample;
          } //if unknown, append sample # to cau filename
       }

    void Load_Tpa()
    {
        OPENFILENAME ofn;
        char szFileName[MAX_PATH] = "";
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize = sizeof(ofn); 
        ofn.hwndOwner = hwnd;
        ofn.lpstrFilter = "Tpa File (*.tpa)\0*.tpa\0";
        ofn.lpstrFile = szFileName;
        ofn.nMaxFile = MAX_PATH;
        ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
        |OFN_PATHMUSTEXIST;
        ofn.lpstrDefExt = "";
        
                
        if(GetOpenFileName(&ofn))
         {    
		   if(fileLoaded==1) {
		   	fclose(tpaFile);
		   	wavCount=0;
		   }  
		    fileLoaded=1;  
            baseFileName=szFileName; 
			
            int chopper= baseFileName.rfind("\\");
            baseFileName.erase(0, chopper+1);
            int rasedots = baseFileName.find(".");
            baseFileName.erase(rasedots,4);   	
			            
          	unsigned long numOf_Entries;
          	unsigned long tpaverType;
 
          	tpaFile = fopen (szFileName, "rb");
          	fseek(tpaFile, 0, SEEK_SET);
          	fread(&tpaverType, sizeof(unsigned long), 1, tpaFile);
            fseek(tpaFile, 0x10, SEEK_CUR);
            fread(&numOf_Entries, sizeof(unsigned long), 1, tpaFile); 
            fseek(tpaFile, 0, SEEK_SET);
			EntryNo=numOf_Entries;
			
			std::stringstream gh;
			gh<<EntryNo;
			std::string showEntNo;
			gh>>showEntNo;
			showEntNo+=" Entries reside within the selected tpa file . . .";
			
			MessageBox(NULL, showEntNo.c_str(), "Caption_Editor", MB_OK);
			
			 if(tpaverType!=336) {
			 	MessageBox(NULL,"Selected tpa is not a retail! Cannot Edit file . . . (file closed)",
				NULL, MB_OK);
			 	fileLoaded=0;
			 	fclose(tpaFile);
			 }             
            } //close ofn
         } //close loader

    void readCaptions ()
      {
    EnableWindow(hForward, false);
    EnableWindow(hExports, false);
    std::string outputcau;
    unsigned char wavbytes;
    unsigned long CaptionLength; //total length of captions
    unsigned long OffSet_To_Dat;
    tempSample = fopen (temp_wavdata.c_str(), "wb");
    
    fseek(tpaFile, 0x1C, SEEK_SET); //Set to first Entry + 8

         if(wavCount==1){
          fseek(tpaFile, 56, SEEK_CUR); // Goto 1st entry (not 0)
         }
   
 	     if(wavCount>1){ 
     	  fseek(tpaFile, wavCount * 56, SEEK_CUR);
 	     }

        fseek(tpaFile, -0x04, SEEK_CUR);
        
        fread(&OurHash_Value, sizeof(unsigned long), 1, tpaFile);
        fread(&OffSet_To_Dat, sizeof(unsigned long), 1, tpaFile);
        
        Retrieve_IDs ();   
		outputcau=holdpathway;
		outputcau+=sound_sample;   
		outputcau+=".cau";		
        
        fseek(tpaFile, OffSet_To_Dat, SEEK_SET);
        
        fread(&RobWyatt, sizeof(unsigned long), 1, tpaFile); 
        fread(&SampType, sizeof(unsigned long), 1, tpaFile);
        fread(&Size_OfHeader, sizeof(unsigned long), 1, tpaFile);        
        fread(&Compress_Type, sizeof(unsigned long), 1, tpaFile);
        fread(&size_of_Data,  sizeof(unsigned long), 1, tpaFile);
        
        fseek(tpaFile, Size_OfHeader-20, SEEK_CUR);
		
		for(int x=0; x<size_of_Data; x++) //save raw wav data
		 {
		fread(&wavbytes, sizeof(unsigned char), 1, tpaFile);
		fwrite(&wavbytes, sizeof(unsigned char), 1, tempSample);
		 }   
		
		fclose(tempSample);
		fseek(tpaFile, OffSet_To_Dat+20, SEEK_SET);   
        
        fread(&size_of_Wave,  sizeof(unsigned long), 1, tpaFile);
        fread(&Sample_Rate,   sizeof(unsigned long), 1, tpaFile);
        fread(&BitRate_Chans, sizeof(unsigned long), 1, tpaFile);
        fread(&Is_Caption,    sizeof(unsigned long), 1, tpaFile);
        
        CauSampSize=Size_OfHeader+size_of_Data; //original size
        //if edited, we'd need to adjust not only the cau sample
        //but all offsets as well so we hold this original size
        //so we can adjust all affected values -
 
         if(Is_Caption==36){
          EnableWindow(hNewCaptions, true);
          EnableWindow(hExports, true);
          fread(&CaptionLength, sizeof(unsigned long), 1, tpaFile);
          OldCapLength=CaptionLength;
          fseek(tpaFile, 0x4, SEEK_CUR);//Goto start of caption data
        
         if(post_Caption.length()>0){
          post_Caption.erase();
           }
        
          std::stringstream captionFeed;
          unsigned char capbyte;
        
         for(long int b=0; b<CaptionLength-8; ++b)
          {
           capbyte=0;
           fread(&capbyte, sizeof(unsigned char), 1, tpaFile);
           
            if(capbyte>31){
              captionFeed<<capbyte;
            }
            
	            if(capbyte<31 && !capbyte==0){ 
	              captionFeed<<" ";
	            }
             }
           post_Caption=captionFeed.str(); // to $ for display
        }
         else {  //no caption data - extract sample as is
         	EnableWindow(hNewCaptions, false);
         	outSample = fopen (outputcau.c_str(), "wb");
         	post_Caption="No Captions . . .";
         	fseek(tpaFile, OffSet_To_Dat, SEEK_SET);
         	for (int y=0; y<size_of_Data+36; y++){
         	 fread(&wavbytes, sizeof(unsigned char), 1, tpaFile);
		     fwrite(&wavbytes, sizeof(unsigned char), 1, outSample);	         		
         	}
          fclose(outSample);
		  sound_sample.erase();	
		  MessageBeep(0x00000040L);
         }   
		  EnableWindow(hForward, true);                
        }   
        
///////////////////////////////////////////////////////////////////
  
 void read_newcaps()
{
            char* linea_buf;

              unsigned long TLenCount;
              unsigned long LineCount;
              unsigned long fourzeros=0;
              unsigned char iszero=0;
              unsigned char iselvn=14;
              
              FILE *capFile;

              BOOL bExitFired=FALSE;
              BOOL bShowMsgBox=FALSE;
  
            int edline1 = GetWindowTextLength(GetDlgItem(hwnd,IDE_NEWCAPS));
            
            if(edline1 > 0) 
              {
              	MessageBeep(0x00000040L);
                linea_buf = (char*)GlobalAlloc(GPTR, edline1 + 1);
                GetDlgItemText(hwnd, IDE_NEWCAPS, linea_buf, edline1 + 1);
               
                TLenCount=edline1+53; // may omit the extra data at end (5)
                LineCount=1;
              
                std::ofstream capsout(temp_capdata.c_str(), std::ios::out | std::ios::binary);
                capsout<<linea_buf;
                capsout.close();
                
               // unsigned char numReturns;
               char numReturns;
                
                std::fstream numType(temp_capdata.c_str(), std::ios::in | std::ios::binary);
                numType.seekg(0, std::ios::beg);
         
            while (numType.read(&numReturns, 1)){
                 if(numReturns==13){
                  LineCount+=1;
                  TLenCount+=3;
                  }
                 }
                numType.close();
                GlobalFree((HANDLE)linea_buf); 
        
		std::string outputcau2;      
        outputcau2=holdpathway;
		outputcau2+=sound_sample;   
		outputcau2+=".cau";		

         FILE *cauout;  
		 FILE *rawavs;       
         cauout = fopen(outputcau2.c_str(), "wb");
         rawavs = fopen(temp_wavdata.c_str(), "rb");
                 
////////////////////////////////////////////////////////////////
        fwrite(&RobWyatt, sizeof(unsigned long), 1, cauout);
        fwrite(&SampType, sizeof(unsigned long), 1, cauout);
        fwrite(&TLenCount, sizeof(unsigned long), 1, cauout);        
        fwrite(&Compress_Type, sizeof(unsigned long), 1, cauout);
        fwrite(&size_of_Data,  sizeof(unsigned long), 1, cauout);
        fwrite(&size_of_Wave,  sizeof(unsigned long), 1, cauout);
        fwrite(&Sample_Rate,   sizeof(unsigned long), 1, cauout);
        fwrite(&BitRate_Chans, sizeof(unsigned long), 1, cauout);
        fwrite(&Is_Caption,    sizeof(unsigned long), 1, cauout);

////////////////////////////////////////////////////////////////         
         
         unsigned long sentenceLen=TLenCount-40;
         fwrite(&sentenceLen,sizeof(unsigned long),1,cauout);
         
         fwrite(&LineCount, sizeof(unsigned long), 1,cauout);
         
         unsigned long MiliSecs=10;
         fwrite(&MiliSecs, sizeof(unsigned long), 1, cauout);
         
         unsigned char testchar;
         
         capFile = fopen(temp_capdata.c_str(), "rb");
         
          for (int c=0; c<edline1; c++){
         fread(&testchar, sizeof(char), 1, capFile);
         
         if(testchar=='\n'){
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iselvn,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
          }
         
         if(testchar==10 || testchar==13 || testchar==0){
         //do nothing, really. ..
         testchar=0;
         }
         else{
         fwrite(&testchar, sizeof(char), 1, cauout);
         }
          }
         fclose(capFile);
 
         fwrite(&fourzeros, sizeof(unsigned long),1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         
         DeleteFile(temp_capdata.c_str());
         
         int z = 0;
         unsigned char readbits;
         
          while (z<size_of_Data) {
           fread(&readbits, sizeof(unsigned char), 1, rawavs);
		   fwrite(&readbits, sizeof(unsigned char), 1, cauout);
		   z++;
          }
         fclose(cauout);
         fclose(rawavs);
         }
          else {
          	MessageBeep(0);
          }
        }    
        
void Caus_to_EELFile ()
 {
 	       FILE *tpaout;
 	       
 	       if(baseFileName.length()<4) {
 	       	 baseFileName="CEditor";
 	       } //means no tpa file was loaded at time of clicking 'done'
 	       //therefore, cannot assign tpa name to eel file -
 	       
           loadeddir=0;
           int cauCount=1;
           
           std::string cauFullPath;
           std::string chopcau;
           eelfileName=holdpathway;
           std::string caupaths=holdpathway;
           eelfileName+=baseFileName;
           eelfileName+="_rebuild.eel";      
           
           std::string exttype = "*.cau"; // only look for this file type
           std::string opnthisLoc = holdpathway + exttype;           
           

           WIN32_FIND_DATA file;
           HANDLE hFind;
           
           hFind=FindFirstFile(opnthisLoc.c_str(), &file);
           cauCount++;
 
            while (FindNextFile(hFind, &file)>0)
            {
             cauCount++; //just count # of .cau files
           }
            FindClose(hFind);
            
            if(fileLoaded==0) {
              EntryNo=cauCount;
            }
           
 /////////////  Below, write out eel file //////////////////////           
		if (cauCount>3)	{
			 loadeddir=1;
             hFind=FindFirstFile(opnthisLoc.c_str(), &file);
             cauFullPath=caupaths;
             cauFullPath+=file.cFileName;
             std::ofstream cauLocale(eelfileName.c_str(), std::ios::out);
             cauLocale<<3<<std::endl;
             cauLocale<<cauCount<<std::endl;
             cauLocale<<"MISSING"<<std::endl;
             cauLocale<<"missing.cau"<<std::endl;
             cauLocale<<0<<std::endl;
             cauLocale<<0<<std::endl;
             chopcau=file.cFileName;
             chopcau.erase(chopcau.length()-4, 4);
             cauLocale<<chopcau<<std::endl;
             cauLocale<<cauFullPath<<std::endl;
             cauLocale<<0<<std::endl;
             cauLocale<<0<<std::endl;
             cauFullPath.erase();
             chopcau.erase();
             
             
          
        while (FindNextFile(hFind, &file)>0) 
         {
             cauFullPath=caupaths;
             cauFullPath+=file.cFileName;
             chopcau=file.cFileName;
             chopcau.erase(chopcau.length()-4, 4);
             cauLocale<<chopcau<<std::endl;
             cauLocale<<cauFullPath<<std::endl;
             cauLocale<<0<<std::endl;
             cauLocale<<0<<std::endl;
             cauFullPath.erase();
             chopcau.erase();
           }
             cauLocale<<0<<std::endl;
             cauLocale<<0<<std::endl;
             cauLocale.close();	
             FindClose(hFind);
        }
         else {
         	MessageBeep(0);
         }
          }
       

